package pl.polkomtel.kontakt.jbpm.fork;

import java.util.Date;
import java.util.List;

import org.jbpm.api.ProcessInstance;
import org.jbpm.api.job.Job;
import org.jbpm.api.task.Task;
import org.jbpm.test.JbpmTestCase;

public class AsyncForkTest extends JbpmTestCase {

	  String deploymentId;
	  
	  protected void setUp() throws Exception {
	    super.setUp();
	    
	    deploymentId = repositoryService.createDeployment()
	        .addResourceFromClasspath("pl/polkomtel/kontakt/jbpm/fork/asyncFork.jpdl.xml")
	        .deploy();
	  }

	  protected void tearDown() throws Exception {
	    repositoryService.deleteDeploymentCascade(deploymentId);
	    
	    super.tearDown();
	  }

	  public void testAsyncFork() {
	    ProcessInstance processInstance = executionService.startProcessInstanceByKey("asyncFork");
	    String processInstanceId = processInstance.getId();
	    
	    List<Job> jobs = managementService.createJobQuery()
	      .processInstanceId(processInstanceId)
	      .list();

	    assertEquals(3, jobs.size());
	    
	    Job job = jobs.get(0);

	    managementService.executeJob(job.getId());
	    
	    job = jobs.get(1);

	    managementService.executeJob(job.getId());
	    
	    job = jobs.get(2);

	    managementService.executeJob(job.getId());
	    
	    List<Task> taskList = taskService.findPersonalTasks("alex");

		assertEquals(taskList.size(), 1);
		
		Task task = taskList.get(0);
		
		taskService.completeTask(task.getId());

	    Date endTime = historyService
	      .createHistoryProcessInstanceQuery()
	      .processInstanceId(processInstance.getId())
	      .uniqueResult()
	      .getEndTime();

	    assertNotNull(endTime);
	  }
}
